/**
 * Copyright © 2020 2021 2022 7thCode.(http://seventh-code.com/)
 * This software is released under the MIT License.
 * opensource.org/licenses/mit-license.php
 */
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isType = exports.isContainer = exports.isValue = exports.isNumber = void 0;
/**
 * isNumber
 *
 * @remarks
 * is Number?
 *
 * @param value - unknown value.
 * @returns True/False
 */
function isNumber(value) {
    return ((typeof value === 'number') && (isFinite(value)));
}
exports.isNumber = isNumber;
/**
 * isValue
 *
 * @remarks
 * 値がnull,undef以外
 *
 * @param value - 値
 * @returns null,undef以外
 */
function isValue(value) {
    return ((value !== null) && (typeof value !== 'undefined'));
}
exports.isValue = isValue;
/**
 * isObject
 *
 * @remarks
 * 値がオブジェクトか.
 * [],{}はオブジェクト。
 *
 * @param value - 値
 * @returns オブジェクトか
 */
function isContainer(value) {
    return ((value !== null) && (typeof value === 'object'));
}
exports.isContainer = isContainer;
/**/
function isType(value) {
    let result = typeof value;
    if (Array.isArray(value)) {
        result = "array";
    }
    return result;
}
exports.isType = isType;
