/**
 * Copyright © 2020 2021 2022 7thCode.(http://seventh-code.com/)
 * This software is released under the MIT License.
 * opensource.org/licenses/mit-license.php
 */
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StructDiff = exports.DetectHandler = void 0;
const base_1 = require("./base");
/**
     * Handler
     *
     * @remarks
     * 値が同一か？
     *
     * @param s
     * @param d
     * @returns boolean
     *
*/
class DetectHandler {
}
exports.DetectHandler = DetectHandler;
class StructDiff {
    constructor(handler = null) {
        this.handler = handler;
    }
    isSameValue(s, d, comp_type) {
        let result = true;
        if (this.handler) {
            if (this.handler.compare) {
                result = this.handler.compare(s, d);
            }
        }
        else {
            switch (comp_type) {
                case 0:
                    result = ((0, base_1.isType)(s) === (0, base_1.isType)(d));
                    break;
                case 1:
                    result = (s === d);
                    break;
                case 2:
                    result = true;
                    break;
                default:
            }
        }
        return result;
    }
    isSame(s, d, comp_type = 0) {
        let result = true;
        if (((0, base_1.isValue)(s)) && ((0, base_1.isValue)(d))) {
            if (((0, base_1.isContainer)(s)) && ((0, base_1.isContainer)(d))) {
                const attrs_s = Object.keys(s);
                const attrs_d = Object.keys(d);
                if (attrs_s.length === attrs_d.length) {
                    attrs_s.sort();
                    attrs_d.sort();
                    for (let index = 0; index < attrs_s.length; index++) {
                        if (attrs_s[index] === attrs_d[index]) {
                            let attr = attrs_s[index];
                            if (!(this.isSame(s[attr], d[attr], comp_type))) {
                                result = false;
                                break;
                            }
                        }
                        else {
                            result = false;
                            break;
                        }
                    }
                }
                else {
                    result = false;
                }
            }
            else {
                result = this.isSameValue(s, d, comp_type);
            }
        }
        else {
            result = false;
        }
        return result;
    }
}
exports.StructDiff = StructDiff;
